package edu.mermet.tp8.fenetres;

import javax.swing.*;
import java.awt.*;
import java.util.*;

public class CommentFaire extends JDialog {

    private JEditorPane editPane;
    private HashMap<String,String> hm;
    private JList<Object> jl;

    public CommentFaire(){
        setSize(400,400);
        setLayout(new BorderLayout());
        setTitle("Comment Faire ?");

        inithashMap();

        jl = new JList<>(hm.keySet().toArray());
        jl.addListSelectionListener(evt -> {
            if (!CommentFaire.this.jl.getValueIsAdjusting()) {
                CommentFaire.this.editPane.setText(CommentFaire.this.hm.get(CommentFaire.this.jl.getSelectedValue()));
            }
        });

        editPane = new JEditorPane();
        editPane.setEditable(false);
        editPane.setContentType("text/html");

        JSplitPane js = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,jl,editPane);
        add(js);

        setVisible(true);
    }

    private void inithashMap(){
        ResourceBundle howToTitres = ResourceBundle.getBundle("HowTo/titres");
        ResourceBundle howToTextes = ResourceBundle.getBundle("HowTo/textes");
        Enumeration<String> clesTitres = howToTitres.getKeys();
        Enumeration<String> clesTextes = howToTextes.getKeys();

        hm = new HashMap<>();

        while(clesTitres.hasMoreElements() && clesTextes.hasMoreElements()){
            String titres = clesTitres.nextElement();
            String textes = clesTextes.nextElement();
            hm.put(howToTitres.getString(titres),howToTextes.getString(textes));
        }
    }

}
