package edu.mermet.tp8.fenetres;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.util.*;

public class ConfigurationMenu extends JDialog {

    private JRadioButton autoConv;
    private JRadioButton afficheConv;
    private JRadioButton cacheConv;

    private JRadioButton autoTexte;
    private JRadioButton afficheTexte;
    private JRadioButton cacheTexte;

    private JRadioButton autoDiaporama;
    private JRadioButton afficheDiaporama;
    private JRadioButton cacheDiaporama;

    private JRadioButton autoBoutons;
    private JRadioButton afficheBoutons;
    private JRadioButton cacheBoutons;


    public ConfigurationMenu(JFrame frame) {
        setLayout(new FlowLayout());
        setTitle("Configuration des menus");

        JPanel main = new JPanel();
        main.setLayout(new BoxLayout(main, BoxLayout.Y_AXIS));

        /** Ligne Conversion **/
        JPanel conversion = new JPanel();
        conversion.setLayout(new FlowLayout());
        JLabel convLabel = new JLabel("Conversion fahreneit / Celsius");
        conversion.add(convLabel);

        ButtonGroup btg = new ButtonGroup();

        autoConv = new JRadioButton("Auto");
        btg.add(autoConv);
        conversion.add(autoConv);

        afficheConv = new JRadioButton("Affiché");
        btg.add(afficheConv);
        conversion.add(afficheConv);

        cacheConv = new JRadioButton("Caché");
        btg.add(cacheConv);
        conversion.add(cacheConv);

        main.add(conversion);

        /** Ligne Saisie de Texte **/
        JPanel texte = new JPanel();
        texte.setLayout(new FlowLayout());
        JLabel texteLabel = new JLabel("Saisie de Texte");
        texte.add(texteLabel);

        ButtonGroup btgTexte = new ButtonGroup();

        autoTexte = new JRadioButton("Auto");
        btgTexte.add(autoTexte);
        texte.add(autoTexte);

        afficheTexte = new JRadioButton("Affiché");
        btgTexte.add(afficheTexte);
        texte.add(afficheTexte);

        cacheTexte = new JRadioButton("Caché");
        btgTexte.add(cacheTexte);
        texte.add(cacheTexte);

        main.add(texte);

        /** Ligne diaporama **/
        JPanel diaporama = new JPanel();
        diaporama.setLayout(new FlowLayout());
        JLabel diaporamaLabel = new JLabel("Diaporama");
        diaporama.add(diaporamaLabel);

        ButtonGroup btgDiaporama = new ButtonGroup();

        autoDiaporama = new JRadioButton("Auto");
        btgDiaporama.add(autoDiaporama);
        diaporama.add(autoDiaporama);

        afficheDiaporama = new JRadioButton("Affiché");
        btgDiaporama.add(afficheDiaporama);
        diaporama.add(afficheDiaporama);

        cacheDiaporama = new JRadioButton("Caché");
        btgDiaporama.add(cacheDiaporama);
        diaporama.add(cacheDiaporama);

        main.add(diaporama);

        /** Ligne boutons **/
        JPanel boutons = new JPanel();
        boutons.setLayout(new FlowLayout());
        JLabel boutonsLabel = new JLabel("Boutons");
        boutons.add(boutonsLabel);

        ButtonGroup btgBoutons = new ButtonGroup();

        autoBoutons = new JRadioButton("Auto");
        btgBoutons.add(autoBoutons);
        boutons.add(autoBoutons);

        afficheBoutons = new JRadioButton("Affiché");
        btgBoutons.add(afficheBoutons);
        boutons.add(afficheBoutons);

        cacheBoutons = new JRadioButton("Caché");
        btgBoutons.add(cacheBoutons);
        boutons.add(cacheBoutons);

        main.add(boutons);

        /** Boutons Valider - Quitter **/
        JPanel bas = new JPanel();
        bas.setLayout(new FlowLayout());

        Action validerAction = new Valider();
        JButton valider = new JButton(validerAction);
        bas.add(valider);

        Action quitterAction = new Quitter();
        JButton quitter = new JButton(quitterAction);
        bas.add(quitter);

        main.add(bas);

        add(main);

        pack();

        initChecked();
        setVisible(true);

    }

    private void initChecked() {
        ResourceBundle configMenu = ResourceBundle.getBundle("configMenu");
        HashMap hm = new HashMap<>();
        Enumeration<String> config = configMenu.getKeys();

        hm.put("conversion",  configMenu.getString(config.nextElement()));
        hm.put("texte",  configMenu.getString(config.nextElement()));
        hm.put("diaporama",  configMenu.getString(config.nextElement()));
        hm.put("boutons", configMenu.getString(config.nextElement()));

        Set<Map.Entry<String, String>> setLhm = hm.entrySet();
        Iterator<Map.Entry<String, String>> it = setLhm.iterator();
        while(it.hasNext()){
            Map.Entry<String, String> e = it.next();
            switch(e.getKey()) {
                case "conversion" : if(e.getValue().equals("Auto")) autoConv.setSelected(true);
                                    if(e.getValue().equals("Affiche")) afficheConv.setSelected(true);
                                    if(e.getValue().equals("Cache")) cacheConv.setSelected(true);
                    break;
                case "texte" :  if(e.getValue().equals("Auto")) autoTexte.setSelected(true);
                                if(e.getValue().equals("Affiche")) afficheTexte.setSelected(true);
                                if(e.getValue().equals("Cache")) cacheTexte.setSelected(true);
                    break;
                case "diaporama" :  if(e.getValue().equals("Auto")) autoDiaporama.setSelected(true);
                                    if(e.getValue().equals("Affiche")) afficheDiaporama.setSelected(true);
                                    if(e.getValue().equals("Cache")) cacheDiaporama.setSelected(true);
                    break;
                case "boutons" :    if(e.getValue().equals("Auto")) autoBoutons.setSelected(true);
                                    if(e.getValue().equals("Affiche")) afficheBoutons.setSelected(true);
                                    if(e.getValue().equals("Cache")) cacheBoutons.setSelected(true);
                    break;
            }
            System.out.println(e.getKey() + " : " + e.getValue());
        }
    }

    class Valider extends AbstractAction {
        public Valider() {
            super("Valider");
        }

        public void actionPerformed(ActionEvent e) {

        }
    }

    class Quitter extends AbstractAction {
        public Quitter() {
            super("Quitter");
        }

        public void actionPerformed(ActionEvent e) {
            dispose();
        }
    }
}
