package edu.mermet.tp8.fenetres;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.beans.PropertyChangeEvent;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.text.NumberFormat;
import java.util.Locale;

/**
 *
 * @author brunomermet
 */
public class FenetreConversionMonnaie extends AbstractFenetreInterne {
    private JComboBox champMonnaie;
    private JComboBox champMonnaie2;
    private JTextField champMonnaieText1;
    private JButton boutonConvertir;
    private Action actionConvertir;
    private JLabel res;
    private boolean celsiusAFocus;
    public FenetreConversionMonnaie(Action action) {
        super(action,"Conversion celsius/Farenheit");
        this.setSize(new Dimension(100,50));
        this.setLayout(new GridLayout(3,1));

        String[] data = {"France (Euro)", "Anglais (Livre)", "Américain (Dollars)"};

        JPanel ligneCelsius = new JPanel();
        ligneCelsius.setLayout(new FlowLayout(FlowLayout.TRAILING));
        champMonnaie = new JComboBox(data);
        ligneCelsius.add(champMonnaie);
        champMonnaieText1 = new JTextField(15);
        ligneCelsius.add(champMonnaieText1);
        this.add(ligneCelsius);
        celsiusAFocus = true;
        JPanel ligneFarenheit = new JPanel();
        ligneFarenheit.setLayout(new FlowLayout(FlowLayout.TRAILING));
        champMonnaie2 = new JComboBox(data);
        ligneFarenheit.add(champMonnaie2);
        res = new JLabel("");
        ligneFarenheit.add(res);
        this.add(ligneFarenheit);
        JPanel ligneValider = new JPanel();
        ligneValider.setLayout(new FlowLayout(FlowLayout.CENTER));
        actionConvertir = new ActionConvertir();
        boutonConvertir = new JButton(actionConvertir);
        ligneValider.add(boutonConvertir);
        this.add(ligneValider);

        pack();
        getRootPane().setDefaultButton(boutonConvertir);
    }

    private class ActionConvertir extends AbstractAction {

        public ActionConvertir() {
            super("Convertir");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            Locale ici = new Locale("fr","FR");
            switch(champMonnaie2.getSelectedIndex()) {
                case 0: ici = new Locale("fr","FR"); break;
                case 1: ici = new Locale("en","EN"); break;
            }
            double resDouble = findExchangeRateAndConvert("EUR","USD",Double.parseDouble(champMonnaieText1.getText()));
            NumberFormat nf = NumberFormat.getNumberInstance(ici);
            res.setText(nf.format(resDouble));
        }
    }

    public void propertyChange(PropertyChangeEvent evt) {
        switch (evt.getNewValue().toString()){
            case "FR":

                break;
            case "EN":

                break;
        }
    }

    private static Double findExchangeRateAndConvert(String from, String to, double amount) {
        try {
            //Yahoo Finance API
            URL url = new URL("http://finance.yahoo.com/d/quotes.csv?f=l1&s="+ from + to + "=X");
            BufferedReader reader = new BufferedReader(new InputStreamReader(url.openStream()));
            String line = reader.readLine();
            if (line.length() > 0) {
                return Double.parseDouble(line) * amount;
            }
            reader.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return 100.0;
    }


}
